﻿using System;
using System.Collections.Generic;
using System.Text;

namespace Ex03.GarageLogic
{
    public class ElectricMotorcycle : Motorcycle, IElectricBased
    {
        private const float k_MaximumBatteryTime = 1.4f;
        private readonly ElectricEngine r_ElectricEngine;

        public ElectricMotorcycle()
        {
            r_ElectricEngine = new ElectricEngine(0.0f, k_MaximumBatteryTime);
        }

        public override void ParseFields(Dictionary<string, string> i_Form)
        {
            base.ParseFields(i_Form);
            float percentage = (float.Parse(RemainingEnergyPercentage) / 100) * ElectricEnergySource.MaximumBattreyTime;
            RemainingEnergyPercentage = percentage.ToString();
        }

        public ElectricEngine ElectricEnergySource
        {
            get { return r_ElectricEngine; }
        }

        public void Recharge(float i_TimeToAdd, ref Vehicle io_Vehicle)
        {
            r_ElectricEngine.Recharge(i_TimeToAdd, ref io_Vehicle);
        }

        public override string ToString()
        {
            StringBuilder stringBuilder = new StringBuilder();

            stringBuilder.Append(base.ToString());
            stringBuilder.Append(r_ElectricEngine.ToString());

            return stringBuilder.ToString();
        }
    }
}
