﻿using System;
using System.Collections.Generic;
using System.Text;

namespace Ex03.GarageLogic
{
    public class FuelMotorcycle : Motorcycle, IFuelBased
    {
        private const FuelEngine.eFuelType k_FuelType = FuelEngine.eFuelType.Octan95;
        private const float k_MaximumFuelCapacity = 5.0f;
        private readonly FuelEngine r_FuelEngine;

        public FuelMotorcycle()
        {
            r_FuelEngine = new FuelEngine(k_FuelType, 0.0f, k_MaximumFuelCapacity);
        }

        public override void ParseFields(Dictionary<string, string> i_Form)
        {
            base.ParseFields(i_Form);
            float percentage = (float.Parse(RemainingEnergyPercentage) / 100) * FuelPowerSource.MaximumFuelLevel;
            RemainingEnergyPercentage = percentage.ToString();
        }

        public override string ToString()
        {
            StringBuilder stringBuilder = new StringBuilder();

            stringBuilder.Append(base.ToString());
            stringBuilder.Append(r_FuelEngine.ToString());

            return stringBuilder.ToString();
        }

        public FuelEngine FuelPowerSource
        {
            get { return r_FuelEngine; }
        }

        public void Refuel(float i_LitresToAdd, FuelEngine.eFuelType i_FuelType, ref Vehicle io_Vehicle)
        {
            r_FuelEngine.Refuel(i_LitresToAdd, i_FuelType, ref io_Vehicle);
        }
    }
}
