﻿using System;
using System.Collections.Generic;
using System.Text;

namespace Ex04.Menus.Delegates
{
    public class ActionItem : MenuItem
    {
        public delegate void ActionDelegate();

        public event ActionDelegate ActionToDoWhenSelected;

        public ActionItem()
        {
            ActionToDoWhenSelected = null;
        }

        public ActionItem(string i_Title, ActionDelegate i_ActionDelegate)
        {
            Title = i_Title;
            ActionToDoWhenSelected += i_ActionDelegate;
        }

        internal override void DoWhenSelected()
        {
            if (ActionToDoWhenSelected == null)
            {
                Console.WriteLine("Item not initalized yet.");
            }
            else
            {
                ActionToDoWhenSelected.Invoke();
            }
        }
    }
}